<?php 
/*##################################################
*  Mytemplate Engine version 1.4
* http://moffed.com
* http://Dev-ly.com 
*   $Authors = array( 
*   		Bruce 	=>  Prof.Bruce@yahoo.it ,
*  			Saanina	=>   saanina@gmail.com 
*			);
*###################################################
*################## LAST CHANGES ###################
*   last change  was : 01:41 pm - 23:6:2008 AC - 20/06/1429AH 
*   last edit by : saanina..
*	Re-Writing the class to be easy understand the codes
****/
   
class MyTemplate
{ 
	//
	//vars of class
	//
	var $Tempdir	=	'../style/template'; 
	var $cachedir	=	'../cach'; 
	var $cachetime	= 24; //by hour  
	var $php_compile	= 'on';
	var $vars		= array();
	//style of paging 
	var $sty_pg		=	' style="background-color: #F9F9F9;border: 1px solid #666666;font-size: 14px;color: #666666;padding: 0px 3px 0px 3px;margin: 1px;width: 4px;height: 4px;" ';
	var $sty_on_pg	=	' style="background-color: #666666;color: #FFFFFF;font-size: 14px;color: #FFFFFF;padding: 0px 3px 0px 3px;margin: 1px;width: 4px;height: 4px;" ';
   

	/**
	* Remove any PHP tags that do not belong, these regular expressions are derived from
	* the ones that exist in zend_language_scanner.
	* access : privat ..
	*/
	
	function remove_php_tags(&$code)
	{
				$match = array(
					'#<([\?%])=?.*?\1>#s',
					'#<script\s+language\s*=\s*(["\']?)php\1\s*>.*?</script\s*>#s',
					'#<\?php(?:\r\n?|[ \n\t]).*?\?>#s'
				);

				$code = preg_replace($match, '', $code);
	}
	
	/**
	* compile our codes to be real code ..
	* accses : private..
	*/
	
    function compile($content)
	{ 
	
			//loop 
			$content = preg_replace_callback('#{loop=([a-zA-Z0-9\_\-\+\./]+)(.*?)\}(.*?){\/loop\}#is',array(&$this,'loop_bt'), $content);
			//if and her sisters
			$content = preg_replace_callback('#{(if|elseif)[^>]([a-zA-Z0-9\_\-\+\./]+)[^>]([a-zA-Z\=\!\>\%\&\|\</]{1,3})[^>](.*?)\}#i',array(&$this,'if_expr'), $content);

			//matchs ..
			$matchs	= array('#{include_tpl[^>](.*?)\}#i',
							'#{include_script[^>](.*?)\}#i',
							'#{if[^>]([a-zA-Z0-9\_\-\+\./]+)\}#i',
							'#{elseif[^>]([a-zA-Z0-9\_\-\+\./]+)\}#i',
							'#{else\}#i',
							'#{\/if\}#i',
							($this->php_compile == 'on') ? '#{php\}(.*?){\/php\}#is' : '##',
							'#{([a-zA-Z0-9\_\-\+\./]+)}#',
							
							);
			//replaces				
			$replaces = array ( '<?php $this->include_tpl(\'\\1\'); ?>',
								'<?php include(\'\\1\'); ?>',
								'<?php if($this->vars[\'\\1\']){ ?>',
								'<?php } elseif(\\1){?>',
								'<?php } else { ?>',
								'<?php } ?>',
								($this->php_compile == 'on') ? '<?php \\1 ?>' : '',
								'<?php print $this->vars[\'\\1\'];?>',
								
								);
		//show time ..
		$content = preg_replace($matchs, $replaces, $content);

		return $content; 
    } 
	
	/**
	* assign variables ... i mean make copy from variable to use it in our template ..
	* we have 2 type , singal or array ..
	* access : public ..
	**/
	function assign($name, $value)
	{
		$this->vars[$name] = $value;
	}
	
	//for array
    function assign_r($array)
	{
		foreach($array as $key=>$value) $this->assign($key, $value);
	}
	

	/*
	*including another template in current one ,,, its prety and helpful .. ;)
	* access : public ..
	*/
	function include_tpl($tpl_page)
	{
		print $this->show($tpl_page);
	}
	
	/*
	*this is the father of template engine ,, i dont why i love play with it , its like my little kid :)
	* access : private ..
	**/
	function loop_bt ($match_loop) 
	{ 
			//matchs ..
			$matchs = array('#{odd[^>]([a-zA-Z0-9\_\-\+\./]+)\}(.*?){\/odd\}#is',
							'#{even[^>]([a-zA-Z0-9\_\-\+\./]+)\}(.*?){\/even\}#is',
							'#{\/if\}#i',
							'#{([a-zA-Z0-9\_\-\+\./]+)}#',
							'#{rand=(.*?),(.*?)}#i',
							'#{%value%}#',
							'#{%key%}#',
							);
			
			//replaces
			$replaces = array( '<?php if(intval($value[\'\\1\'])%2){?> \\2 <?php } ?>',
								'<?php if(intval($value[\'\\1\'] % 2) == 0){?> \\2 <?php } ?>',
								'<?php } ?>',
								'<?php print $value[\'\\1\'];?>',
								'<?php $rand_' . $match_loop[1] . '=($rand_'.$match_loop[1].'==0)?1:0; print(($rand_'.$match_loop[1].'==1) ?"\\1":"\\2") ;?>',
								'<?php print $value; ?>',
								'<?php print $key; ?>',
							);
			
			//show time
			$content_loop = preg_replace($matchs, $replaces, $match_loop[3]); 
			
			$extra_s	=	$ops 	=	$extra_e =	'';
			if($match_loop[2] && strpos($match_loop[2], 'limit'))
			{
				$limit_n	=	str_replace(array('limit=',' '),'', $match_loop[2]);
				$limit_n	=	(strpos($limit_n, '_')!== false) ? $this->vars[trim(substr($limit_n, 1))] : $limit_n;
				$ops		=	'$this->lp_pages("'.$match_loop[1].'", '.$limit_n.');';
				$extra_s	=	'if($i_for_'.$match_loop[1].' >=  $this->vars[\'ops2_'.$match_loop[1].'\']) { ';
				$extra_e	=	'} $i_for_'.$match_loop[1].'++;  if($i_for_'.$match_loop[1].' >= $this->vars[\'ops3_'.$match_loop[1].'\']) { break; } '. "" ;
			}
			
			return ('<?php /*loop*/ '.$ops.' $i_for_'.$match_loop[1].'=0;foreach($this->vars[\''.$match_loop[1].'\'] as $key=>$value){ '.$extra_s.' ?>'. $content_loop .'<?php ' . $extra_e.' } /*endloop*/ ?>');
	}

	//
	//for pages
	//
	function lp_pages ($arr_name, $rows)
	{
	
		$num_rows		=	sizeof($GLOBALS[$arr_name]);
		
        $totalPages		=	@ceil($num_rows/$rows);
		$current_page	=	intval($_GET['mytpage']);
		print $totalPages;
        if ($current_page < 1) $current_page	=	1; 
        else if ($current_page > $totalPages) $current_page	= $totalPages; 
        
		//assign page 
		if($totalPages > 2)
		{
			$link = (strpos($_SERVER['QUERY_STRING'], '?') === false) ? '?' : '&amp;';
			$re = ($current_page>1) ? '<a href="'. $link .'mytpage='.($current_page-1).'" '. $this->sty_pg .'>  &lt; </a>&#160;': '';
			for($s=1;$s<$totalPages+1;$s++) $re .= ($current_page==$s) ? '<span '. $this->sty_on_pg .'>' . $s . '</span>' : '<a href="' . $link . 'mytpage=' . $s . '" '. $this->sty_pg .'>' . $s . '</a>';
			$re .= ($current_page<$totalPages) ? '&#160;<a href="'.$link.'mytpage='.($current_page+1).'" '. $this->sty_pg .'> &gt; </a>': '';
	
			$pg_array_n	=	$re;
		}
		else
		{
			$pg_array_n	=	'&nbsp;';
		}
		
		$this->vars['ops2_' . $arr_name]	= (($current_page -1)* $rows);
		$this->vars['ops3_' . $arr_name]	= ($current_page * $rows);
		$this->vars['pg_' . $arr_name]	=	$pg_array_n;
	}
	
	
	/*
	for if / elseif experssions ,, 
	acsess : private ..
	*/
	function if_expr(&$match)
	{
		//if it's IF .. 
		if (strtolower(trim($match[1])) == 'if')
		{
			$result .= 'if ('; 	
		}
		elseif(strtolower(trim($match[1])) == 'elseif')
		{
			$result .= '} elseif('; 	
		}
		
		///its for loop or just normal if ..  [ loop begin with __
		if (strpos($match[2], '__') !== false)
		{
			$val = str_replace('__','',$match[2]);
			$result .= '$value[\''.trim($val).'\']'; 
			
		}
		else
		{
			$result .= '$this->vars[\''.trim($match[2]).'\']'; 
		}
		
		//so , now experssions signs .. 
		
		if (!empty($match[3]))
		{
			$expr = trim(strtolower($match[3]));
			
				switch($expr)
				{
					case '=': case '==': case 'eq':
					$expr_is = '==';
					break;
					case '!=': case '<>': case 'ne': case 'neq':
					$expr_is = '!=';
					break;
					case '<': case 'lt':
					$expr_is = '<';
					break;
					case '<=': case 'le': case 'lte':
					$expr_is = '<=';
					break;
					case '>': case 'gt':
					$expr_is = '>';
					break;
					case '>=':case 'ge': case 'gte':
					$expr_is = '>=';
					break;
					case '&&': case 'and':
					$expr_is = '&&';
					break;
					case '||': case 'or':
					$expr_is = '||';
					break;
					case '!': case 'not':
					$expr_is = '!';
					break;
					case '%': case 'mod':
					$expr_is = '%';
					break;
					default:
					$expr_is = $expr;
				}
				
				$result .= ' ' . $expr_is . ' '; 
		}
		
				//whats match4 .. its something cant change it now .. i will do something good with it later .. 
				$result .= $match[4];
				
				//some .. additions
				$result .= '){';
		
		//return it 
		return '<?php '.$result. '?>';
	}
	
	
	/**
	* now , showing our template ,, its prety function
	* we have 2 type , by filename or just by contents ..
	* name_c : just if there is contents not from file ..
	* access : public ..
	**/
	
    function show($content, $name_c='', $cache_time = false)
	{ 
		//at first .. 
		$page_is	= ($name_c!='') ? $name_c :  $content;
		$cache_time	= ($cache_time != false )? $cache_time : $this->cachetime;
		
		//global vars 
		if (empty($this->vars) || !is_array($this->vars)) $this->vars = array();
		$this->vars = @array_merge($this->vars, $GLOBALS);

		//check step
	    if (empty($this->cachedir)) $this->cachedir = $_ENV["TEMP"]; 
	    if (!is_writeable( $this->cachedir ) ) echo "<i>ERROR :</i> could not be write in cach folder!";
		
		//delete step
	    $npage        = 'mytpl_' . $page_is . ".php"; 
	    $tpage        = @filemtime("$this->cachedir/$npage"); 
	    if($tpage >= ($tpage+(3600*$cache_time))) @unlink("$this->cachedir/$npage"); 
		
		//including step
	    if(!file_exists("$this->cachedir/$npage"))
		{	
				if ($name_c == '')
				{
					if(!file_exists("$this->Tempdir/$page_is")) exit("<i>ERROR :</i> <b>$page_is</b> Template Does Not Exists!");
					ob_start();
					include("$this->Tempdir/$page_is"); 
					$pageTemp= ob_get_clean();
				}
				else
				{
					$pageTemp = $content;
				}
				
				//reomve any any php tags ,, so if you want php code use our code {php}
				$this->remove_php_tags($pageTemp);
				
				//compile content
				$pageTemp = $this->compile($pageTemp);	
				
				//then
			    $filenum = @fopen("$this->cachedir/$npage", 'w'); 
			    flock($filenum, LOCK_EX); 
			    @fwrite($filenum, $pageTemp); 
			    fclose($filenum); 
				@chmod($filenum, 0666);
				
				
	    } 
		
		
		//get 
		ob_start();
		include("$this->cachedir/$npage"); 
		$pageTemp= ob_get_clean();
		//now prepare to print 
		return $pageTemp;
    } 
     
} # end of class 



?>
